diff -ur ScummVM+orig/scummvm/sky/sound.cpp ScummVM+hack/scummvm/sky/sound.cpp
--- ScummVM+orig/scummvm/sky/sound.cpp	2003-07-07 08:37:36.000000000 +0200
+++ ScummVM+hack/scummvm/sky/sound.cpp	2003-07-07 08:56:04.000000000 +0200
@@ -33,6 +33,14 @@
 #pragma START_PACK_STRUCTS
 #endif
 
+enum {
+	SOUND_CH0    = 0,
+	SOUND_CH1    = 1,
+	SOUND_BG     = 2,
+	SOUND_VOICE  = 3,
+	SOUND_SPEECH = 4
+};
+
 struct RoomList {
 	uint8 room;
 	uint8 adlibVolume;
@@ -1021,7 +1029,6 @@
 	_bgSoundHandle = 0;
 	_ingameSpeech = 0;
 	_ingameSound0 = _ingameSound1 = 0;
-	_spSlot = _slot0 = _slot1 = -1;
 	_saveSounds[0] = _saveSounds[1] = 0xFFFF;
 }
 
@@ -1033,25 +1040,28 @@
 
 int SkySound::playVoice(byte *sound, uint32 size) {
 
-	return playSound(sound, size, &_voiceHandle);
+	_mixer->stopID(SOUND_VOICE);
+	return playSound(SOUND_VOICE, sound, size, &_voiceHandle);
 }
 
 
 int SkySound::playBgSound(byte *sound, uint32 size) {
 
 	size -= 512; //Hack to get rid of the annoying pop at the end of some bg sounds 
-	return playSound(sound, size, &_bgSoundHandle);
+	_mixer->stopID(SOUND_BG);
+	return playSound(SOUND_BG, sound, size, &_bgSoundHandle);
 }
 
-int SkySound::playSound(byte *sound, uint32 size, PlayingSoundHandle *handle) {
+int SkySound::playSound(uint32 id, byte *sound, uint32 size, PlayingSoundHandle *handle) {
 
 	byte flags = 0;
 	flags |= SoundMixer::FLAG_UNSIGNED|SoundMixer::FLAG_AUTOFREE;
 	size -= sizeof(struct dataFileHeader);
 	byte *buffer = (byte *)malloc(size); 
 	memcpy(buffer, sound+sizeof(struct dataFileHeader), size);	
-	
-	return _mixer->playRaw(handle, buffer, size, 11025, flags);
+
+	_mixer->stopID(id);
+	return _mixer->playRaw(handle, buffer, size, 11025, flags, id);
 }
 
 void SkySound::loadSection(uint8 pSection) {
@@ -1074,17 +1084,10 @@
 
 void SkySound::playSound(uint16 sound, uint16 volume, uint8 channel) {
 
-	if (channel == 0) {
-		if ((_slot0 >= 0) && ((_slot0 != _spSlot) || (!_ingameSpeech))) {
-			_mixer->stop(_slot0);
-			_slot0 = -1;
-		}
-	} else {
-		if ((_slot1 >= 0) && ((_slot1 != _spSlot) || (!_ingameSpeech))){
-			_mixer->stop(_slot1);
-			_slot1 = -1;
-		}
-	}
+	if (channel == 0)
+		_mixer->stopID(SOUND_CH0);
+	else
+		_mixer->stopID(SOUND_CH1);
 
 	if (!_soundData) {
 		warning("SkySound::playSound(%04X, %04X) called with a section having been loaded.\n", sound, volume);
@@ -1113,9 +1116,9 @@
 	
 	_mixer->setVolume(volume);
 	if (channel == 0)
-		_slot0 = _mixer->playRaw(&_ingameSound0, _soundData + dataOfs, dataSize, sampleRate, flags);
+		_mixer->playRaw(&_ingameSound0, _soundData + dataOfs, dataSize, sampleRate, flags, SOUND_CH0);
 	else
-		_slot1 = _mixer->playRaw(&_ingameSound1, _soundData + dataOfs, dataSize, sampleRate, flags);
+		_mixer->playRaw(&_ingameSound1, _soundData + dataOfs, dataSize, sampleRate, flags, SOUND_CH1);
 }
 
 void SkySound::fnStartFx(uint32 sound, uint8 channel) {
@@ -1205,9 +1208,8 @@
 }
 
 void SkySound::fnStopFx(void) {
-	if (_slot0 >= 0) _mixer->stop(_slot0);
-	if (_slot1 >= 0) _mixer->stop(_slot1);
-	_slot0 = _slot1 = -1;
+	_mixer->stopID(SOUND_CH0);
+	_mixer->stopID(SOUND_CH1);
 	_saveSounds[0] = _saveSounds[1] = 0xFFFF;
 }
 
@@ -1229,6 +1231,7 @@
 
 	free(speechData);
 
-	_spSlot = _mixer->playRaw(&_ingameSpeech, playBuffer, speechSize, 11025, SoundMixer::FLAG_UNSIGNED | SoundMixer::FLAG_AUTOFREE);
+	_mixer->stopID(SOUND_SPEECH);
+	_mixer->playRaw(&_ingameSpeech, playBuffer, speechSize, 11025, SoundMixer::FLAG_UNSIGNED | SoundMixer::FLAG_AUTOFREE);
 	return true;
 }
diff -ur ScummVM+orig/scummvm/sky/sound.h ScummVM+hack/scummvm/sky/sound.h
--- ScummVM+orig/scummvm/sky/sound.h	2003-07-05 18:33:25.000000000 +0200
+++ ScummVM+hack/scummvm/sky/sound.h	2003-07-07 08:52:13.000000000 +0200
@@ -47,7 +47,7 @@
 
 protected:
 
-	int playSound(byte *sound, uint32 size, PlayingSoundHandle *handle);
+	int playSound(uint32 id, byte *sound, uint32 size, PlayingSoundHandle *handle);
 
 public:
 	SkySound(SoundMixer *mixer, SkyDisk *pDisk);
@@ -72,7 +72,6 @@
 	uint16 _sfxBaseOfs;
 	uint8 *_soundData;
 	uint8 *_sampleRates, *_sfxInfo;
-	int _slot0, _slot1, _spSlot;
 
 	static uint16 _speechConvertTable[8];
 	static SfxQueue _sfxQueue[MAX_QUEUED_FX];