diff -ur ScummVM-cvs20040212/scummvm/README ScummVM-cvs20040212+hack/scummvm/README
--- ScummVM-cvs20040212/scummvm/README	2004-02-09 11:54:54.000000000 +0100
+++ ScummVM-cvs20040212+hack/scummvm/README	2004-02-13 07:28:06.000000000 +0100
@@ -364,7 +364,8 @@
   --native-mt32            True Roland MT-32 (disable GM emulation)
   --aspect-ratio           Enable aspect ratio correction
 
-  --floppy-intro           Use floppy version intro for Beneath a Steel Sky CD
+  --alt-intro              Use alternative intro for CD versions of Beneath a
+                           Steel Sky and Flight of the Amazon Queen
   --copy-protection        Enable copy protection in SCUMM games ,when
                            ScummVM disables it by default.
   --demo-mode              Start demo mode of Maniac Mansion (Classic version)
@@ -879,8 +880,9 @@
         copy_protection bool     Enable copy protection in SCUMM games ,when
                                  ScummVM disables it by default.
         demo_mode       bool     Start demo in Maniac Mansion (Classic version)
-        floppy_intro    bool     Use floppy version of introduction in Beneath
-                                 a Steel Sky (CD version)
+        alt_intro       bool     Use alternative intro for CD versions of
+                                 Beneath a Steel Sky and Flight of the Amazon
+                                 Queen
 
         boot_param      number   Pass this number to the boot script
         debuglevel      number   Enable debug output. The higher number, the
diff -ur ScummVM-cvs20040212/scummvm/base/gameDetector.cpp ScummVM-cvs20040212+hack/scummvm/base/gameDetector.cpp
--- ScummVM-cvs20040212/scummvm/base/gameDetector.cpp	2004-02-09 08:58:31.000000000 +0100
+++ ScummVM-cvs20040212+hack/scummvm/base/gameDetector.cpp	2004-02-13 06:38:12.000000000 +0100
@@ -79,8 +79,9 @@
 	"  --native-mt32            True Roland MT-32 (disable GM emulation)\n"
 	"  --aspect-ratio           Enable aspect ratio correction\n"
 	"\n"
-#ifndef DISABLE_SKY
-	"  --floppy-intro           Use floppy version intro for Beneath a Steel Sky CD\n"
+#if !defined(DISABLE_SKY) || !defined(DISABLE_QUEEN)
+	"  --alt-intro              Use alternative intro for CD versions of Beneath a\n"
+        "                           Steel Sky and Flight of the Amazon Queen\n"
 #endif
 #ifndef DISABLE_SCUMM
 	"  --copy-protection        Enable the original copy protection in SCUMM games\n"
@@ -136,8 +137,8 @@
 	ConfMan.registerDefault("tempo", 0);
 #endif
 
-#ifndef DISABLE_SKY
-	ConfMan.registerDefault("floppy_intro", false);
+#if !defined(DISABLE_SKY) || !defined(DISABLE_QUEEN)
+	ConfMan.registerDefault("alt_intro", false);
 #endif
 
 	// Miscellaneous
@@ -439,9 +440,9 @@
 			END_OPTION
 #endif
 
-#ifndef DISABLE_SKY
-			DO_LONG_OPTION_BOOL("floppy-intro")
-				ConfMan.set("floppy_intro", cmdValue, kTransientDomain);
+#if !defined(DISABLE_SKY) || !defined(DISABLE_QUEEN)
+			DO_LONG_OPTION_BOOL("alt-intro")
+				ConfMan.set("alt_intro", cmdValue, kTransientDomain);
 			END_OPTION
 #endif
 
diff -ur ScummVM-cvs20040212/scummvm/doc/05_01.tex ScummVM-cvs20040212+hack/scummvm/doc/05_01.tex
--- ScummVM-cvs20040212/scummvm/doc/05_01.tex	2004-02-09 11:54:58.000000000 +0100
+++ ScummVM-cvs20040212+hack/scummvm/doc/05_01.tex	2004-02-13 06:39:49.000000000 +0100
@@ -37,7 +37,8 @@
   --native-mt32           &True Roland MT-32 (disable GM emulation)\\
   --aspect-ratio          &Enable aspect ratio correction\\
 \\
-  --floppy-intro          &Use floppy version intro for Beneath a Steel Sky CD\\
+  --alt-intro             &Use alternative intro for CD versions of Beneath a\\
+                          &Steel Sky and Flight of the Amazon Queen\\
   --copy-protection       &Enable copy protection in SCUMM games, when\\
                           &ScummVM disables it by default.\\
   --demo-mode             &Start demo mode of Maniac Mansion (Classic version)\\
diff -ur ScummVM-cvs20040212/scummvm/doc/08.tex ScummVM-cvs20040212+hack/scummvm/doc/08.tex
--- ScummVM-cvs20040212/scummvm/doc/08.tex	2004-02-07 23:36:21.000000000 +0100
+++ ScummVM-cvs20040212+hack/scummvm/doc/08.tex	2004-02-13 07:27:30.000000000 +0100
@@ -105,8 +105,9 @@
         copy\_protection&bool     Enable copy protection in SCUMM games ,when\\
                         &         ScummVM disables it by default.\\
         demo\_mode      &bool     Start demo in Maniac Mansion (Classic version)\\
-        floppy\_intro   &bool     Use floppy version of introduction in Beneath\\
-                        &         a Steel Sky (CD version)\\
+        alt\_intro      &bool     Use alternative intro for CD versions of \\
+                        &         Beneath a Steel Sky and Flight of the Amazon\\
+                        &         Queen
 \\
         boot\_param     &number   Pass this number to the boot script\\
         debuglevel      &number   Enable debug output. The higher number, the\\
diff -ur ScummVM-cvs20040212/scummvm/sky/sky.cpp ScummVM-cvs20040212+hack/scummvm/sky/sky.cpp
--- ScummVM-cvs20040212/scummvm/sky/sky.cpp	2004-02-05 08:24:14.000000000 +0100
+++ ScummVM-cvs20040212+hack/scummvm/sky/sky.cpp	2004-02-13 06:40:18.000000000 +0100
@@ -123,7 +123,7 @@
 	
 	_debugMode = ConfMan.hasKey("debuglevel");
 
-	_floppyIntro = ConfMan.getBool("floppy_intro");
+	_floppyIntro = ConfMan.getBool("alt_intro");
 
 	_fastMode = 0;
 